'use strict';

var vue = require('vue');
var useNameSpace = require('../_util/hooks/useNameSpace2.js');
var _interface = require('./interface.js');
var utils = require('./utils.js');
require('../render/index.js');
var Render = require('../render/Render.js');

var _sfc_main = /* @__PURE__ */ vue.defineComponent({
  __name: "TableHeader",
  setup(__props) {
    const { props, leftFixedColumsRef, rightFixedColumsRef, fixedColumnLeftMapRef, fixedColumnRightMapRef } = vue.inject(_interface.dataTableContextKey);
    const { prefixCls, columns, scrollX } = vue.toRefs(props);
    const ns = useNameSpace(prefixCls.value);
    return (_ctx, _cache) => {
      return vue.openBlock(), vue.createElementBlock(
        "div",
        {
          class: vue.normalizeClass(vue.unref(ns).e("header"))
        },
        [
          vue.createElementVNode(
            "table",
            {
              class: vue.normalizeClass(vue.unref(ns).e("table")),
              style: vue.normalizeStyle(`width: ${vue.unref(scrollX)}px`)
            },
            [
              vue.createElementVNode(
                "thead",
                {
                  class: vue.normalizeClass(vue.unref(ns).e("thead"))
                },
                [
                  vue.createElementVNode(
                    "tr",
                    {
                      class: vue.normalizeClass(vue.unref(ns).e("tr"))
                    },
                    [
                      (vue.openBlock(true), vue.createElementBlock(
                        vue.Fragment,
                        null,
                        vue.renderList(vue.unref(columns), (col, index) => {
                          return vue.openBlock(), vue.createElementBlock(
                            "th",
                            {
                              class: vue.normalizeClass({
                                [vue.unref(ns).e("th")]: true,
                                [vue.unref(utils.getColumnClassName)(col, index)]: true,
                                [vue.unref(ns).e(`th-fix-${col.fixed}`)]: col.fixed,
                                [vue.unref(ns).e("td-fix-right-first")]: col === vue.unref(rightFixedColumsRef)[0],
                                [vue.unref(ns).e("td-fix-left-last")]: col === vue.unref(leftFixedColumsRef)[vue.unref(leftFixedColumsRef).length - 1],
                                [vue.unref(ns).em("th-align", col.align)]: col.align
                              }),
                              style: vue.normalizeStyle({
                                width: col.width + "px",
                                left: vue.unref(fixedColumnLeftMapRef)[col.key] + "px",
                                right: vue.unref(fixedColumnRightMapRef)[col.key] + "px"
                              })
                            },
                            [
                              vue.createVNode(vue.unref(Render), {
                                render: col.title,
                                data: col
                              }, null, 8, ["render", "data"])
                            ],
                            6
                            /* CLASS, STYLE */
                          );
                        }),
                        256
                        /* UNKEYED_FRAGMENT */
                      ))
                    ],
                    2
                    /* CLASS */
                  )
                ],
                2
                /* CLASS */
              )
            ],
            6
            /* CLASS, STYLE */
          )
        ],
        2
        /* CLASS */
      );
    };
  }
});

module.exports = _sfc_main;
