import { defineComponent, inject, toRefs, openBlock, createElementBlock, normalizeClass, unref, createElementVNode, normalizeStyle, Fragment, renderList, createVNode } from 'vue';
import useNamespace from '../_util/hooks/useNameSpace2.js';
import { dataTableContextKey } from './interface.js';
import { getColumnClassName } from './utils.js';
import '../render/index.js';
import Render from '../render/Render.js';

var _sfc_main = /* @__PURE__ */ defineComponent({
  __name: "TableHeader",
  setup(__props) {
    const { props, leftFixedColumsRef, rightFixedColumsRef, fixedColumnLeftMapRef, fixedColumnRightMapRef } = inject(dataTableContextKey);
    const { prefixCls, columns, scrollX } = toRefs(props);
    const ns = useNamespace(prefixCls.value);
    return (_ctx, _cache) => {
      return openBlock(), createElementBlock(
        "div",
        {
          class: normalizeClass(unref(ns).e("header"))
        },
        [
          createElementVNode(
            "table",
            {
              class: normalizeClass(unref(ns).e("table")),
              style: normalizeStyle(`width: ${unref(scrollX)}px`)
            },
            [
              createElementVNode(
                "thead",
                {
                  class: normalizeClass(unref(ns).e("thead"))
                },
                [
                  createElementVNode(
                    "tr",
                    {
                      class: normalizeClass(unref(ns).e("tr"))
                    },
                    [
                      (openBlock(true), createElementBlock(
                        Fragment,
                        null,
                        renderList(unref(columns), (col, index) => {
                          return openBlock(), createElementBlock(
                            "th",
                            {
                              class: normalizeClass({
                                [unref(ns).e("th")]: true,
                                [unref(getColumnClassName)(col, index)]: true,
                                [unref(ns).e(`th-fix-${col.fixed}`)]: col.fixed,
                                [unref(ns).e("td-fix-right-first")]: col === unref(rightFixedColumsRef)[0],
                                [unref(ns).e("td-fix-left-last")]: col === unref(leftFixedColumsRef)[unref(leftFixedColumsRef).length - 1],
                                [unref(ns).em("th-align", col.align)]: col.align
                              }),
                              style: normalizeStyle({
                                width: col.width + "px",
                                left: unref(fixedColumnLeftMapRef)[col.key] + "px",
                                right: unref(fixedColumnRightMapRef)[col.key] + "px"
                              })
                            },
                            [
                              createVNode(unref(Render), {
                                render: col.title,
                                data: col
                              }, null, 8, ["render", "data"])
                            ],
                            6
                            /* CLASS, STYLE */
                          );
                        }),
                        256
                        /* UNKEYED_FRAGMENT */
                      ))
                    ],
                    2
                    /* CLASS */
                  )
                ],
                2
                /* CLASS */
              )
            ],
            6
            /* CLASS, STYLE */
          )
        ],
        2
        /* CLASS */
      );
    };
  }
});

export { _sfc_main as default };
